/**
 * 
 * This class is part of the Preclipse Tutorial 
 * 
 * http://www.preclipse.de/
 * 
 * This program and the accompanying materials are made
 * available under the terms of the General Public License 
 * which accompanies this distribution.
 * 
 */
package de.preclipse.DVDStorage;
import java.io.IOException;
import java.util.List;

import org.prevayler.Prevayler;

import de.preclipse.DVDStorage.bo.DVDStorage;
import de.preclipse.DVDStorage.gui.DVDStorageGUI;
import de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener;
import de.preclipse.DVDStorage.transaction.DVDCompleteChangeTransaction;
import de.preclipse.DVDStorage.transaction.DVDCreateTransaction;
import de.preclipse.DVDStorage.transaction.DVDDeleteTransaction;

/**
 * 
 * @author Preclipse Team
 * 
 */
public class GUIControl implements DVDStorageGUIActionListener {
	
	
	private Prevayler prevayler;
	
	public GUIControl(Prevayler prevayler) {
		this.prevayler = prevayler;
		DVDStorageGUI.showGUIPrevail(this);
	}
	

	/* (non-Javadoc)
	 * @see de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener#newDVDAction(java.lang.String, int, int, java.lang.String, java.lang.String)
	 */
	public void newDVDAction(String name, int year, int length, String imdb,
			String comment) throws Exception {
		
		prevayler.execute(new DVDCreateTransaction(name, year, length, imdb, comment));
		
	}
	
	/* (non-Javadoc)
	 * @see de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener#changeDVDAction(java.lang.String, java.lang.String, int, int, java.lang.String, java.lang.String)
	 */
	public void changeDVDAction(long ID, String name, int year, int length,
			String imdb, String comment) throws Exception {
		
		prevayler.execute(new DVDCompleteChangeTransaction(ID, name, year, length, imdb, comment));
		
	}
	/* (non-Javadoc)
	 * @see de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener#deleteAction(java.lang.String)
	 */
	public void deleteAction(long ID) {
		
		prevayler.execute(new DVDDeleteTransaction(ID));
		
	}
	/* (non-Javadoc)
	 * @see de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener#snapshotAction()
	 */
	public void snapshotAction() throws IOException {
		
		prevayler.takeSnapshot();
	}
	/* (non-Javadoc)
	 * @see de.preclipse.DVDStorage.gui.DVDStorageGUIActionListener#getDVDList()
	 */
	public List getDVDList() {
		
		return ((DVDStorage)prevayler.prevalentSystem()).getDVDList();
	}
}
