/**
 * 
 * This class is part of the Preclipse Tutorial 
 * 
 * http://www.preclipse.de/
 * 
 * This program and the accompanying materials are made
 * available under the terms of the General Public License 
 * which accompanies this distribution.
 * 
 */
package de.preclipse.DVDStorage.bo;
import java.io.Serializable;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import de.preclipse.DVDStorage.bo.DVD;
/**
 * @author Preclipse Team
 *  
 */
public class DVDStorage implements Serializable {
	private List dvdList = new ArrayList();
	private long nextDVDID = 1;
	/**
	 *  
	 */
	public DVDStorage() {
		super();
	}
	/**
	 * Returns the DVD list for use by the GUI.
	 * 
	 * @return List of DVD objects
	 */
	public List getDVDList() {
		return dvdList;
	}
	/**
	 * @return
	 */
	public DVD addDVD() {
		DVD newDVD = new DVD(nextDVDID++);
		this.dvdList.add(newDVD);
		return newDVD;
	}
	/**
	 * @param ID
	 * @return
	 */
	public DVD getDVD(long ID) {
		for (Iterator i = dvdList.iterator(); i.hasNext();) {
			DVD currentDVD = (DVD) i.next();
			if (currentDVD.getID() == ID)
				return currentDVD;
		}
		return null;
	}
	/**
	 * @param ID
	 * @return
	 */
	public boolean removeDVD(long ID) {
		for (Iterator i = dvdList.iterator(); i.hasNext();) {
			DVD currentDVD = (DVD) i.next();
			if (currentDVD.getID() == ID) {
				i.remove();
				return true;
			}
		}
		return false;
	}
}
