/**
 * 
 * This class is part of the Preclipse Tutorial 
 * 
 * http://www.preclipse.de/
 * 
 * This program and the accompanying materials are made
 * available under the terms of the General Public License 
 * which accompanies this distribution.
 * 
 */
package de.preclipse.DVDStorage.gui;

import java.io.IOException;
import java.net.URL;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

import de.preclipse.DVDStorage.bo.DVD;


/**
 * 
 * This class represents the GUI of DVDStorage, a sample program
 * demonstrating the use of the Preclipse plugin (www.preclipse.de).
 * 
 * The GUI parts of this class have been generated using 
 * CloudGarden's Jigloo SWT/Swing GUI Builder, which is a very
 * cool tool for creating GUIs and free for non-commercial use
 * (see www.cloudgarden.com).
 * 
 * @author Preclipse Team
 * 
 */
public class DVDStorageGUI extends org.eclipse.swt.widgets.Composite {

	// ** GUI STUFF **

	private Label label7;
	
	private ToolItem newButton;
	private TableColumn lengthColumn;
	private TableColumn yearColumn;
	private TableColumn nameColumn;
	private Table dvdTable;
	private Text yearField;
	private ToolItem snapshotButton;
	private ToolItem deleteButton;
	private Text commentField;

	private Text lengthField;
	private Text nameField;

	private Button updateButton;
	private Label commentLabel;
	private Text imdbField;
	private Label imdbLabel;
	
	TableViewer dvdTableViewer;

	private Label lengthLabel;

	private Label yearLabel;

	private Label nameLabel;
	private Composite bottomComposite;

	private ToolItem exitButton;
	public static int MODE_NEW = 0;
	public static int MODE_EDIT = 1;

	public int mode = MODE_NEW;

	private ToolBar theToolbar;
	
	// ** REGULAR STUFF
	
	private DVD currentDVD;

	private DVDStorageGUIActionListener control;
	
	
	// ** METHODS
	
	public DVDStorageGUI(Composite parent, int style) {
		super(parent, style);
		initGUI();
	}
	/**
	* Initializes the GUI.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void initGUI(){
		try {
			preInitGUI();
			theToolbar = new ToolBar(this,SWT.FLAT| SWT.HORIZONTAL| SWT.H_SCROLL);
			newButton = new ToolItem(theToolbar,SWT.NULL);
			deleteButton = new ToolItem(theToolbar,SWT.NULL);
			snapshotButton = new ToolItem(theToolbar,SWT.NULL);
			exitButton = new ToolItem(theToolbar,SWT.NULL);
			dvdTable = new Table(this,SWT.SINGLE| SWT.FULL_SELECTION| SWT.V_SCROLL| SWT.BORDER);
			nameColumn = new TableColumn(dvdTable,SWT.NULL);
			yearColumn = new TableColumn(dvdTable,SWT.NULL);
			lengthColumn = new TableColumn(dvdTable,SWT.NULL);
			bottomComposite = new Composite(this,SWT.NULL);
			nameLabel = new Label(bottomComposite,SWT.HORIZONTAL| SWT.SHADOW_OUT| SWT.RIGHT);
			nameField = new Text(bottomComposite,SWT.BORDER);
			yearLabel = new Label(bottomComposite,SWT.RIGHT);
			yearField = new Text(bottomComposite,SWT.BORDER);
			lengthLabel = new Label(bottomComposite,SWT.RIGHT);
			lengthField = new Text(bottomComposite,SWT.BORDER);
			imdbLabel = new Label(bottomComposite,SWT.RIGHT);
			imdbField = new Text(bottomComposite,SWT.BORDER);
			commentLabel = new Label(bottomComposite,SWT.RIGHT);
			commentField = new Text(bottomComposite,SWT.MULTI| SWT.WRAP| SWT.BORDER);
			label7 = new Label(bottomComposite,SWT.NULL);
			updateButton = new Button(bottomComposite,SWT.PUSH| SWT.CENTER);
			this.setSize(new org.eclipse.swt.graphics.Point(445,388));
			final Color DVDLocalGUIbackground = new Color(Display.getDefault(),236,233,216);
			this.setBackground(DVDLocalGUIbackground);
			GridData theToolbarLData = new GridData();
			theToolbarLData.verticalAlignment = GridData.CENTER;
			theToolbarLData.horizontalAlignment = GridData.BEGINNING;
			theToolbarLData.widthHint = 426;
			theToolbarLData.heightHint = 29;
			theToolbarLData.horizontalIndent = 0;
			theToolbarLData.horizontalSpan = 1;
			theToolbarLData.verticalSpan = 1;
			theToolbarLData.grabExcessHorizontalSpace = true;
			theToolbarLData.grabExcessVerticalSpace = false;
			theToolbar.setLayoutData(theToolbarLData);
			theToolbar.setSize(new org.eclipse.swt.graphics.Point(426,29));
			newButton.setText("New");
			newButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					newButtonWidgetSelected(evt);
				}
			});
			deleteButton.setText("Delete");
			deleteButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					deleteButtonWidgetSelected(evt);
				}
			});
			snapshotButton.setText("Snapshot");
			snapshotButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					snapshotButtonWidgetSelected(evt);
				}
			});
			exitButton.setText("Exit");
			exitButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					exitButtonWidgetSelected(evt);
				}
			});
			theToolbar.setLayout(null);
			GridData dvdTableLData = new GridData();
			dvdTableLData.verticalAlignment = GridData.CENTER;
			dvdTableLData.horizontalAlignment = GridData.BEGINNING;
			dvdTableLData.widthHint = 397;
			dvdTableLData.heightHint = 106;
			dvdTableLData.horizontalIndent = 0;
			dvdTableLData.horizontalSpan = 1;
			dvdTableLData.verticalSpan = 1;
			dvdTableLData.grabExcessHorizontalSpace = false;
			dvdTableLData.grabExcessVerticalSpace = false;
			dvdTable.setLayoutData(dvdTableLData);
			dvdTable.setHeaderVisible(true);
			dvdTable.setLinesVisible(true);
			dvdTable.setSize(new org.eclipse.swt.graphics.Point(397,106));
			dvdTable.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					dvdTableWidgetSelected(evt);
				}
			});
			nameColumn.setText("Name:");
			nameColumn.setWidth(291);
			yearColumn.setText("Year:");
			yearColumn.setWidth(50);
			lengthColumn.setText("Length:");
			lengthColumn.setWidth(50);
			dvdTable.setLayout(null);
			GridData bottomCompositeLData = new GridData();
			bottomCompositeLData.verticalAlignment = GridData.CENTER;
			bottomCompositeLData.horizontalAlignment = GridData.BEGINNING;
			bottomCompositeLData.widthHint = 421;
			bottomCompositeLData.heightHint = 213;
			bottomCompositeLData.horizontalIndent = 0;
			bottomCompositeLData.horizontalSpan = 1;
			bottomCompositeLData.verticalSpan = 1;
			bottomCompositeLData.grabExcessHorizontalSpace = false;
			bottomCompositeLData.grabExcessVerticalSpace = false;
			bottomComposite.setLayoutData(bottomCompositeLData);
			bottomComposite.setSize(new org.eclipse.swt.graphics.Point(421,213));
			GridData nameLabelLData = new GridData();
			nameLabelLData.verticalAlignment = GridData.CENTER;
			nameLabelLData.horizontalAlignment = GridData.BEGINNING;
			nameLabelLData.widthHint = 60;
			nameLabelLData.heightHint = 20;
			nameLabelLData.horizontalIndent = 0;
			nameLabelLData.horizontalSpan = 1;
			nameLabelLData.verticalSpan = 1;
			nameLabelLData.grabExcessHorizontalSpace = false;
			nameLabelLData.grabExcessVerticalSpace = false;
			nameLabel.setLayoutData(nameLabelLData);
			nameLabel.setText("Name:");
			nameLabel.setSize(new org.eclipse.swt.graphics.Point(60,20));
			GridData nameFieldLData = new GridData();
			nameFieldLData.verticalAlignment = GridData.CENTER;
			nameFieldLData.horizontalAlignment = GridData.BEGINNING;
			nameFieldLData.widthHint = 224;
			nameFieldLData.heightHint = 13;
			nameFieldLData.horizontalIndent = 0;
			nameFieldLData.horizontalSpan = 1;
			nameFieldLData.verticalSpan = 1;
			nameFieldLData.grabExcessHorizontalSpace = false;
			nameFieldLData.grabExcessVerticalSpace = false;
			nameField.setLayoutData(nameFieldLData);
			nameField.setSize(new org.eclipse.swt.graphics.Point(224,13));
			GridData yearLabelLData = new GridData();
			yearLabelLData.verticalAlignment = GridData.CENTER;
			yearLabelLData.horizontalAlignment = GridData.BEGINNING;
			yearLabelLData.widthHint = 60;
			yearLabelLData.heightHint = 20;
			yearLabelLData.horizontalIndent = 0;
			yearLabelLData.horizontalSpan = 1;
			yearLabelLData.verticalSpan = 1;
			yearLabelLData.grabExcessHorizontalSpace = false;
			yearLabelLData.grabExcessVerticalSpace = false;
			yearLabel.setLayoutData(yearLabelLData);
			yearLabel.setText("Year:");
			yearLabel.setSize(new org.eclipse.swt.graphics.Point(60,20));
			GridData yearFieldLData = new GridData();
			yearFieldLData.verticalAlignment = GridData.CENTER;
			yearFieldLData.horizontalAlignment = GridData.BEGINNING;
			yearFieldLData.widthHint = 57;
			yearFieldLData.heightHint = 13;
			yearFieldLData.horizontalIndent = 0;
			yearFieldLData.horizontalSpan = 1;
			yearFieldLData.verticalSpan = 1;
			yearFieldLData.grabExcessHorizontalSpace = false;
			yearFieldLData.grabExcessVerticalSpace = false;
			yearField.setLayoutData(yearFieldLData);
			yearField.setSize(new org.eclipse.swt.graphics.Point(57,13));
			GridData lengthLabelLData = new GridData();
			lengthLabelLData.verticalAlignment = GridData.CENTER;
			lengthLabelLData.horizontalAlignment = GridData.BEGINNING;
			lengthLabelLData.widthHint = 60;
			lengthLabelLData.heightHint = 20;
			lengthLabelLData.horizontalIndent = 0;
			lengthLabelLData.horizontalSpan = 1;
			lengthLabelLData.verticalSpan = 1;
			lengthLabelLData.grabExcessHorizontalSpace = false;
			lengthLabelLData.grabExcessVerticalSpace = false;
			lengthLabel.setLayoutData(lengthLabelLData);
			lengthLabel.setText("Length:");
			lengthLabel.setSize(new org.eclipse.swt.graphics.Point(60,20));
			GridData lengthFieldLData = new GridData();
			lengthFieldLData.verticalAlignment = GridData.CENTER;
			lengthFieldLData.horizontalAlignment = GridData.BEGINNING;
			lengthFieldLData.widthHint = 57;
			lengthFieldLData.heightHint = 13;
			lengthFieldLData.horizontalIndent = 0;
			lengthFieldLData.horizontalSpan = 1;
			lengthFieldLData.verticalSpan = 1;
			lengthFieldLData.grabExcessHorizontalSpace = false;
			lengthFieldLData.grabExcessVerticalSpace = false;
			lengthField.setLayoutData(lengthFieldLData);
			lengthField.setSize(new org.eclipse.swt.graphics.Point(57,13));
			GridData imdbLabelLData = new GridData();
			imdbLabelLData.verticalAlignment = GridData.CENTER;
			imdbLabelLData.horizontalAlignment = GridData.BEGINNING;
			imdbLabelLData.widthHint = 60;
			imdbLabelLData.heightHint = 20;
			imdbLabelLData.horizontalIndent = 0;
			imdbLabelLData.horizontalSpan = 1;
			imdbLabelLData.verticalSpan = 1;
			imdbLabelLData.grabExcessHorizontalSpace = false;
			imdbLabelLData.grabExcessVerticalSpace = false;
			imdbLabel.setLayoutData(imdbLabelLData);
			imdbLabel.setText("IMDB:");
			imdbLabel.setSize(new org.eclipse.swt.graphics.Point(60,20));
			GridData imdbFieldLData = new GridData();
			imdbFieldLData.verticalAlignment = GridData.CENTER;
			imdbFieldLData.horizontalAlignment = GridData.BEGINNING;
			imdbFieldLData.widthHint = 57;
			imdbFieldLData.heightHint = 13;
			imdbFieldLData.horizontalIndent = 0;
			imdbFieldLData.horizontalSpan = 1;
			imdbFieldLData.verticalSpan = 1;
			imdbFieldLData.grabExcessHorizontalSpace = false;
			imdbFieldLData.grabExcessVerticalSpace = false;
			imdbField.setLayoutData(imdbFieldLData);
			imdbField.setSize(new org.eclipse.swt.graphics.Point(57,13));
			GridData commentLabelLData = new GridData();
			commentLabelLData.verticalAlignment = GridData.BEGINNING;
			commentLabelLData.horizontalAlignment = GridData.BEGINNING;
			commentLabelLData.widthHint = 60;
			commentLabelLData.heightHint = 20;
			commentLabelLData.horizontalIndent = 0;
			commentLabelLData.horizontalSpan = 1;
			commentLabelLData.verticalSpan = 1;
			commentLabelLData.grabExcessHorizontalSpace = false;
			commentLabelLData.grabExcessVerticalSpace = false;
			commentLabel.setLayoutData(commentLabelLData);
			commentLabel.setText("Comment:");
			commentLabel.setSize(new org.eclipse.swt.graphics.Point(60,20));
			GridData commentFieldLData = new GridData();
			commentFieldLData.verticalAlignment = GridData.CENTER;
			commentFieldLData.horizontalAlignment = GridData.BEGINNING;
			commentFieldLData.widthHint = 331;
			commentFieldLData.heightHint = 69;
			commentFieldLData.horizontalIndent = 0;
			commentFieldLData.horizontalSpan = 1;
			commentFieldLData.verticalSpan = 1;
			commentFieldLData.grabExcessHorizontalSpace = false;
			commentFieldLData.grabExcessVerticalSpace = false;
			commentField.setLayoutData(commentFieldLData);
			commentField.setSize(new org.eclipse.swt.graphics.Point(331,69));
			GridData label7LData = new GridData();
			label7LData.verticalAlignment = GridData.CENTER;
			label7LData.horizontalAlignment = GridData.BEGINNING;
			label7LData.widthHint = -1;
			label7LData.heightHint = -1;
			label7LData.horizontalIndent = 0;
			label7LData.horizontalSpan = 1;
			label7LData.verticalSpan = 1;
			label7LData.grabExcessHorizontalSpace = false;
			label7LData.grabExcessVerticalSpace = false;
			label7.setLayoutData(label7LData);
			GridData updateButtonLData = new GridData();
			updateButtonLData.verticalAlignment = GridData.CENTER;
			updateButtonLData.horizontalAlignment = GridData.BEGINNING;
			updateButtonLData.widthHint = -1;
			updateButtonLData.heightHint = -1;
			updateButtonLData.horizontalIndent = 0;
			updateButtonLData.horizontalSpan = 1;
			updateButtonLData.verticalSpan = 1;
			updateButtonLData.grabExcessHorizontalSpace = false;
			updateButtonLData.grabExcessVerticalSpace = false;
			updateButton.setLayoutData(updateButtonLData);
			updateButton.setText("Update");
			updateButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					updateButtonWidgetSelected(evt);
				}
			});
			GridLayout bottomCompositeLayout = new GridLayout(2, true);
			bottomComposite.setLayout(bottomCompositeLayout);
			bottomCompositeLayout.marginWidth = 5;
			bottomCompositeLayout.marginHeight = 5;
			bottomCompositeLayout.numColumns = 2;
			bottomCompositeLayout.makeColumnsEqualWidth = false;
			bottomCompositeLayout.horizontalSpacing = 5;
			bottomCompositeLayout.verticalSpacing = 5;
			bottomComposite.layout();
			GridLayout thisLayout = new GridLayout(1, true);
			this.setLayout(thisLayout);
			thisLayout.marginWidth = 5;
			thisLayout.marginHeight = 5;
			thisLayout.numColumns = 1;
			thisLayout.makeColumnsEqualWidth = true;
			thisLayout.horizontalSpacing = 5;
			thisLayout.verticalSpacing = 5;
			this.layout();
			addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					DVDLocalGUIbackground.dispose();
				}
			});
	
			postInitGUI();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
/**
					 * Add your pre-init code in here
					 */
	public void preInitGUI() {
	}
	/**
		 * Add your post-init code in here
		 */
	public void postInitGUI() {
		
		nameField.setFocus();
		dvdTableViewer = new TableViewer(dvdTable);

	}
	
	public void newButtonWidgetSelected(SelectionEvent evt) {
		clearInputFields();
	}

	
	/** Auto-generated event handler method */
	public void deleteButtonWidgetSelected(SelectionEvent evt) {
		ISelection selection = dvdTableViewer.getSelection();

		if (selection instanceof IStructuredSelection) {
			Object first = ((IStructuredSelection) selection).getFirstElement();
			if (first instanceof DVD) {
				DVD selectedDVD = (DVD) first;
				
				control.deleteAction(selectedDVD.getID());
				
				
				dvdTableViewer.refresh();
			} else {
				MessageDialog.openError(this.getShell(), "Nothing selected", "Please select an item from the table");
			}
		}
	}
	

	
	

	/** Auto-generated event handler method */
	public void snapshotButtonWidgetSelected(SelectionEvent evt) {
		try {
			
			control.snapshotAction();
			
			MessageDialog.openInformation(this.getShell(), "Done", "Snapshot taken!");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	

	/** Auto-generated event handler method */
	public void exitButtonWidgetSelected(SelectionEvent evt) {
		System.exit(0);
	}
	

	/** Auto-generated event handler method */
	public void updateButtonWidgetSelected(SelectionEvent evt) {
		// Update
		try {
			int theYear = Integer.parseInt(yearField.getText());
			int theLen = Integer.parseInt(lengthField.getText());
		
			if (mode == MODE_NEW) {

				control.newDVDAction(nameField.getText(), theYear, theLen, imdbField.getText(), commentField.getText());
				
				dvdTableViewer.refresh();
				mode = MODE_NEW;
				clearInputFields();

			} else if (mode == MODE_EDIT) {
				ISelection selection = dvdTableViewer.getSelection();
				if (selection instanceof IStructuredSelection) {
					Object first = ((IStructuredSelection) selection).getFirstElement();
					if (first instanceof DVD) {
						DVD selectedDVD = (DVD) first;
						
						control.changeDVDAction(currentDVD.getID(), nameField.getText(), theYear, theLen, imdbField.getText(), commentField.getText());
				
						dvdTableViewer.refresh();
					} else {
						MessageDialog.openError(this.getShell(), "Unclear information", "Nothing selected!");
					}
				}
			}
		} catch (NumberFormatException e) {
			MessageDialog.openError(
				this.getShell(),
				"Incorrect information",
				"Please enter numbers in the yearField and lengthField fields.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}


	/** Auto-generated event handler method */
	public void dvdTableWidgetSelected(SelectionEvent event) {
		mode = MODE_EDIT;
		ISelection selection = dvdTableViewer.getSelection();

		if (selection instanceof IStructuredSelection) {
			Object first = ((IStructuredSelection) selection).getFirstElement();
			if (first instanceof DVD) {
				this.currentDVD = (DVD) first;
				putIntoForm();
			}
		}
	}
	
	
	private void clearInputFields() {
		
		this.nameField.setText("");
		this.yearField.setText("");
		this.lengthField.setText("");
		this.imdbField.setText("");
		this.commentField.setText("");

		
		this.mode = MODE_NEW;
		this.nameField.setFocus();
	}

	
	private void putIntoForm() {
		this.nameField.setText(currentDVD.getName());
		this.yearField.setText(String.valueOf(currentDVD.getYear()));
		this.lengthField.setText(String.valueOf(currentDVD.getLen()));
		this.imdbField.setText(currentDVD.getImdb());
		this.commentField.setText(currentDVD.getComment());
	}

	
	private void setPrevaylerAndInitialize(DVDStorageGUIActionListener control) {

		this.control = control;
		
		dvdTableViewer.setContentProvider(new DVDTableContentProvider());
		dvdTableViewer.setLabelProvider(new DVDTableLabelProvider());
		dvdTableViewer.setInput(control.getDVDList());


	}
	
	public static void showGUIPrevail(DVDStorageGUIActionListener control) {	
		try {
			Display display = new Display();
			Shell shell = new Shell(display);
			DVDStorageGUI inst = new DVDStorageGUI(shell, SWT.NULL);
			shell.setLayout(new org.eclipse.swt.layout.FillLayout());
			Rectangle shellBounds = shell.computeTrim(0,0,445,388);
			shell.setSize(shellBounds.width, shellBounds.height);
			inst.setPrevaylerAndInitialize(control);
			shell.setText("DVDStorage");
			ImageDescriptor descriptor = ImageDescriptor.createFromURL(new URL("file:icons/cd.gif"));
			Image i = descriptor.createImage();
			shell.setImage(i);
			shell.open();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
			i.dispose();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	

	/**
	* Auto-generated code - any changes you make will disappear!!!
	* This static method creates a new instance of this class and shows
	* it inside a Shell.
	*/
	public static void showGUI(){
		try {
			Display display = new Display();
			Shell shell = new Shell(display);
			DVDStorageGUI inst = new DVDStorageGUI(shell, SWT.NULL);
			shell.setLayout(new org.eclipse.swt.layout.FillLayout());
			Rectangle shellBounds = shell.computeTrim(0,0,445,388);
			shell.setSize(shellBounds.width, shellBounds.height);
			shell.open();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}