/**
 * 
 * This class is part of the Preclipse Tutorial 
 * 
 * http://www.preclipse.de/
 * 
 * This program and the accompanying materials are made
 * available under the terms of the General Public License 
 * which accompanies this distribution.
 * 
 */
package de.preclipse.DVDStorage.transaction;
import java.util.Date;
import org.prevayler.TransactionWithQuery;

import de.preclipse.DVDStorage.bo.DVD;
import de.preclipse.DVDStorage.bo.DVDStorage;
/**
 * 
 * @author Preclipse Team
 * 
 */
public class DVDCompleteChangeTransaction implements TransactionWithQuery {
	private final long id;
	private final String name;
	private final int year;
	private final int len;
	private final String imdb;
	private final String comment;
	/**
	 * @param id
	 * @param name
	 * @param year
	 * @param len
	 * @param imdb
	 * @param comment
	 */
	public DVDCompleteChangeTransaction(long id, String name, int year,
			int len, String imdb, String comment) {
		this.id = id;
		this.name = name;
		this.year = year;
		this.len = len;
		this.imdb = imdb;
		this.comment = comment;
	}
	/**
	 * @param prevalentSystem
	 * @param executionTime
	 * @return
	 */
	public Object executeAndQuery(Object prevalentSystem, Date executionTime)
			throws Exception {
		
		DVD changeDVD = ((DVDStorage)prevalentSystem).getDVD(id);
		changeDVD.setName(name);
		changeDVD.setYear(year);
		changeDVD.setLen(len);
		changeDVD.setImdb(imdb);
		changeDVD.setComment(comment);
		
		return changeDVD;
	}
}