/**
 * 
 * This class is part of the Preclipse Tutorial 
 * 
 * http://www.preclipse.de/
 * 
 * This program and the accompanying materials are made
 * available under the terms of the General Public License 
 * which accompanies this distribution.
 * 
 */
package de.preclipse.DVDStorage.transaction;
import java.util.Date;
import org.prevayler.TransactionWithQuery;

import de.preclipse.DVDStorage.bo.DVD;
import de.preclipse.DVDStorage.bo.DVDStorage;
/**
 * 
 * @author Preclipse Team
 * 
 */
public class DVDCreateTransaction implements TransactionWithQuery {
	private final String name;
	private final int year;
	private final int len;
	private final String imdb;
	private final String comment;
	/**
	 * @param name
	 * @param year
	 * @param len
	 * @param imdb
	 * @param comment
	 */
	public DVDCreateTransaction(String name, int year, int len, String imdb,
			String comment) {
		this.name = name;
		this.year = year;
		this.len = len;
		this.imdb = imdb;
		this.comment = comment;
	}
	/**
	 * @param prevalentSystem
	 * @param executionTime
	 * @return
	 */
	public Object executeAndQuery(Object prevalentSystem, Date executionTime)
			throws Exception {
		
		DVD newDVD = ((DVDStorage)prevalentSystem).addDVD();
		newDVD.setName(name);
		newDVD.setYear(year);
		newDVD.setLen(len);
		newDVD.setImdb(imdb);
		newDVD.setComment(comment);

		return newDVD;
	}
}